--[[
	Creates visible breath smoke, for use in cold environment
	Usage:
		Can be toggled via breath.toggle()
]]
module("breath",seeall)


local lara=item["lara"]

local breathColor=rgb(200,200,200)
local isActive=false

local tmr_breath=0	-- timer id of the breath timer
local co_breath		-- breath coroutine

-- Spawn a breath particle:
local function breathParticle()
	local head_x,_,head_z=lara:getMeshPos(8);
	local mouth_x,mouth_y,mouth_z=lara:getMeshPos(8,0,0,70);

	particle.addSprite(mouth_x, mouth_y, mouth_z,	-- pos x,y,z
		(mouth_x-head_x)*3, 0, (mouth_z-head_z)*3,	-- spd_x, spd_y, spd_z,
		-5,15,0,		-- gravity, falloff_xz, falloff_y
		breathColor,breathColor,
		30,			-- lifetime
		0,30,		-- fadein/out
		"b", 1,		-- mode, sprnr
		10,80,		-- scale_start, scale_end,	
		math.random(360),50		--angle, rotation
	)
end

-- Breath timer function (used as coroutine):
local function breath()
	while true do
		-- spawn some breath paricles:
		for i=0,3 do
			breathParticle()
			coroutine.yield()		
		end	
		-- pause for a second:
		coroutine.yield(30)
	end
end

function toggle(onoff)
	onoff=nil
	if onoff==nil then
		isActive=not isActive
	else
		isActive=onoff
	end
	
	-- stop previus timer-coroutine, if any:
	stopTimer(bTimer)

	-- start breath as a timer-coroutine:
	if isActive then
		co_breath=coroutine.create(breath)
		bTimer=startTimer(3,co_breath)
	end
end

