--[[
	Fire colored particle missiles from Lara's hands
	Usage:
		call missile.fire() or bind it to a key
]]
module("missile",seeall)


local num_active=0	-- number of active missiles
local hand=11;	-- which hand to fire from, 11:right, 14:left
local sprite_nr=0;
local miscol1=rgb(255,255,255,255)        -- startcol
local miscol2=rgb(0,255,0,255)            -- endcol

-- coroutine thread:
local function missile(x,y,z,r,ang)
	local sx,sz
	local floor,ceil
	
	-- calculate horizontal speed from the angle:
	sx=math.sin(ang)*1024/10
	sz=math.cos(ang)*1024/10

	num_active=num_active+1

	for i=0,100 do
		playSfx(150,0,x,y,z)	-- 150: loop sml fires
		
		particle.addSprite(
			x,y,z,
			math.random(-100,100),-200,math.random(-100,100),		-- speeds
			10,			-- gravity
			5,5,		-- x/z falloff
			miscol1,miscol2,
			100,		-- lifetime
			50,50,		-- fade in/out
			"b", sprite_nr,
			30,			-- scale start
			255,		-- scale end
			0,			-- angle
			20			-- rotspeed
		)
		addLight(x,y,z,	rgb(0,0,200,20),2)	-- (r,g,b,a=int),life
		
		-- check before move, so we don't blow up INSIDE a wall.
		-- Note how the returned room number (r) is used as the new room:
		floor,ceil,r=getFloorCeiling(x+sx,y,z+sz,r)
		if floor<y or ceil>y then break end
		
		x=x+sx
		z=z+sz
		
		-- Check collision:
		ci,cs=getColliders(x,y,z,r,1)
		if ci then break end
		
		coroutine.yield()
	end

	-- Explode:
	playSfx(106,0,x,y,z)	-- 105: explosion (106:explvolwas80)
	addFlash(x,y,z,r,rgb(255,0,0),2*1024);
	startQuake(30)

	coroutine.yield()
	num_active=num_active-1
end

function fire()
	if num_active>10 then return end

	local x,y,z,r=lara:getMeshPos(hand)
	local ang=lara:getYaw()	-- the angle which lara is facing
	local co=coroutine.create(missile)

	hand=25-hand	-- swap hands 11<->14

	-- Init params:
	assert(coroutine.resume(co,x,y,z,r,ang))

	-- and resume thread:
	startTimer(1,co)
end
