--[[
	Textbox Tests
]]
module("test_textbox",seeall);

local PI=math.pi
local PI2=2*PI

local isRunning=false
local tmr_rotate=false

-- 

local rot_a=0
--local rot_step=PI/150
local rot_step=PI/30

-- ----------
local testtext="Lorem ipsum dolor sit amet\nconsectetuer volutpat elit\nMauris laoreet Curabitur.\nLaoreet et et pretium\nat ut lacinia pharetra\nsapien nec aliquam."

local function init_rotate()
	rot_a=0
	textBox(0,100,100,"0:"..testtext,rgb(0,0,0,0x88),"l1");
	textBox(1,200,200,"1:"..testtext,rgb(0,0,0xaa,0),"r2");
	textBox(2,300,300,"2:"..testtext,rgb(0,0xaa,0xaa),"l3");
	textBox(3,400,400,"3:"..testtext,rgb(0xaa,0,0xaa,0x88),"c4");
	textBox(4,500,500,"4:"..testtext,rgb(0xff,0,0,0x44),"l5");
	textBox(5,600,600,"5:"..testtext,rgb(0x33,0x77,0x11,0x88),"r6");
end

-- Timer function:
local function rotate()
	local a
	for i=0,5 do
		a=rot_a+i*PI2/6
		textBox(i,300+math.sin(a)*400,400+math.cos(a)*400);
	end
	rot_a=rot_a+rot_step
	return isRunning	-- repeat timer while running
end


-- -----------------

function start()
	if isRunning then stopTimer(tmr_rotate) end
	init_rotate()
	tmr_rotate = startTimer(1,rotate)
	isRunning=true
end

function stop()
	stopTimer(tmr_rotate)
	isRunning=false
	for i=0,5 do
		textBoxOff(i)
	end
end

function toggle()
	if isRunning then
		stop()
	else
		start()
	end
end
